{*******************************************************************}
{* 4x3-bits-multiplier simulation unit for LogicGates7 application *}
{*******************************************************************}

unit binmult43;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, common;

type
  TTableFields = array[1..3, 1..3] of TEdit;
  {*************}
  { TfBinMult43 }
  {*************}
  TfBinMult43 = class(TForm)
    StaticText1: TStaticText;
    Label1, Label2, Label3, Label4, Label5, Label6, Label10, Label11, Label18: TLabel;
    imSwitchA0, imSwitchA1, imSwitchA2, imSwitchB0, imSwitchB1, imSwitchB2, imSwitchB3: TImage;
    shSwitchA0a, shSwitchA0b, shSwitchA1a, shSwitchA2a, shSwitchA1b, shSwitchA2b: TShape;
    shSwitchB0a, shSwitchB0b, shSwitchB1a, shSwitchB1b, shSwitchB2a, shSwitchB2b, shSwitchB3a, shSwitchB3b: TShape;
    shLedA0, shLedA1, shLedA2, shLedB0, shLedB1, shLedB2, shLedB3: TShape;
    shLedC0, shLedC1, shLedC2, shLedC3, shLedC4, shLedC5, shLedC6: TShape;
    laA0, laA1, laA2, laB0, laB1, laB2, laB3: TLabel;
    laC0, laC1, laC2, laC3, laC4, laC5, laC6: TLabel;
    Image1, Image2, Image3, Image4, Image5, Image6, Image7, Image8: TImage;
    Image9, Image10, Image11, Image14, Image15, Image16: TImage;
    Shape1, Shape21, Shape22, Shape23, Shape24, Shape25, Shape26, Shape27, Shape28, Shape29, Shape30: TShape;
    Shape31, Shape32, Shape33, Shape36, Shape55, Shape58, Shape78, Shape81, Shape84, Shape85: TShape;
    Shape86, Shape87, Shape88, Shape89, Shape90, Shape91, Shape92, Shape93, Shape94, Shape95: TShape;
    Shape96, Shape97, Shape98, Shape99, Shape100, Shape101, Shape102, Shape103, Shape104, Shape105: TShape;
    Shape106, Shape107, Shape108, Shape109, Shape110, Shape111, Shape112, Shape113, Shape114, Shape115: TShape;
    Shape116, Shape117, Shape118, Shape119, Shape120, Shape121, Shape122, Shape123, Shape124, Shape125: TShape;
    Shape126, Shape127, Shape128, Shape129, Shape130, Shape131, Shape132, Shape133, Shape134, Shape135: TShape;
    Shape136, Shape137, Shape138, Shape139, Shape140, Shape141, Shape142, Shape143, Shape144, Shape145: TShape;
    Shape146, Shape151, Shape152, Shape153, Shape154, Shape155, Shape156, Shape157, Shape158, Shape159: TShape;
    Shape160, Shape161, Shape162, Shape163, Shape164, Shape165, Shape166, Shape167, Shape169, Shape170: TShape;
    Shape172, Shape173, Shape174, Shape175, Shape176, Shape177, Shape180, Shape181, Shape182, Shape183: TShape;
    Shape184, Shape185, Shape186, Shape187, Shape188, Shape189, Shape190, Shape191, Shape192, Shape193: TShape;
    Shape194, Shape195, Shape196, Shape197, Shape202, Shape203, Shape204, Shape205, Shape206, Shape207: TShape;
    Shape208, Shape209, Shape210, Shape211, Shape212, Shape213, Shape214, Shape215, Shape216, Shape217: TShape;
    Shape218, Shape219, Shape220, Shape221, Shape222, Shape223, Shape224: TShape;
    edMultiplierBin, edMultiplierHex, edMultiplierDec: TEdit;
    edMultiplicandBin, edMultiplicandHex, edMultiplicandDec: TEdit;
    edResultBin, edResultHex, edResultDec: TEdit;
    btClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure imSwitchA0Click(Sender: TObject);
    procedure imSwitchA1Click(Sender: TObject);
    procedure imSwitchA2Click(Sender: TObject);
    procedure imSwitchB0Click(Sender: TObject);
    procedure imSwitchB1Click(Sender: TObject);
    procedure imSwitchB2Click(Sender: TObject);
    procedure imSwitchB3Click(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
  private
    aLeds: TLeds;
    aSwitches: TSwitches;
    bSwitches, bLeds: TStatus;
    edMultTable: TTableFields;
  end;

const
  // Switches description: Data = objects positions (transparent image, long bar shape, short bar shape)
  DSwitches: array[0..6] of TSwitchData = (
    (Name: 'SwitchA0';
     Data: (543, 565, 545)),
    (Name: 'SwitchA1';
     Data: (352, 374, 354)),
    (Name: 'SwitchA2';
     Data: (162, 184, 164)),
    (Name: 'SwitchB0';
     Data: (636, 658, 638)),
    (Name: 'SwitchB1';
     Data: (447, 469, 449)),
    (Name: 'SwitchB2';
     Data: (258, 280, 260)),
    (Name: 'SwitchB3';
     Data: (64, 86, 66))
  );

var
  fBinMult43: TfBinMult43;

implementation

{$R *.lfm}

{ 4x3-bits multiplier: Set switch position; do binary multiplication; turn LEDs on/off; fill-in multiplication-table }

procedure SwitchAndMult(DSwitches: array of TSwitchData; var Switches: TSwitches; var SwitchStatus: TStatus;
  var Leds: TLeds; var LedStatus: TStatus; var MultTable: TTableFields; IX: Integer);

const
  Bits: array[False..True] of Integer = (0, 1);
  HexDigits: array[0..15] of Char = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' );

var
  Exp, Hex1, Hex2, L, I, J: Integer;
  Dec: array[0..2] of Integer;
  InputA: array[0..2] of Boolean;
  InputB: array[0..3] of Boolean;
  Output: TBooleans;

begin
  // Change current input from 0 to +Vs (and vice-versa)
  SwitchStatus[IX] := not SwitchStatus[IX];
  // Corresponding LED status
  LedStatus[IX] := SwitchStatus[IX];
  // Set switch positions
  SwitchesOnOff(DSwitches, Switches, SwitchStatus);
  // Do the multiplication
  for I := 0 to 2 do
    InputA[I] := LedStatus[I];
  for I := 0 to 3 do
    InputB[I] := LedStatus[I + 3];
  Multiplier4x3(InputA, InputB, Output);
  for I := 0 to 6 do
    LedStatus[I + 7] := Output[I];
  // Turn all LEDs on/off
  LedsOnOff(Leds, LedStatus);
  // Fill-in binary values and calculate decimal values
  Dec[0] := 0; Dec[1] := 0; Dec[2] := 0; Exp := 1;
  for I := 1 to 3 do begin
    for J := 1 to 3 do begin
      MultTable[I, J].Text := '';
    end;
  end;
  for I := 0 to 6 do begin
    if I <= 2 then
      MultTable[1, 1].Text := IntToStr(Bits[LedStatus[I]]) + MultTable[1, 1].Text;
    if I <= 3 then
      MultTable[2, 1].Text := IntToStr(Bits[LedStatus[I + 3]]) + MultTable[2, 1].Text;
    MultTable[3, 1].Text := IntToStr(Bits[LedStatus[I + 7]]) + MultTable[3, 1].Text;
    if I <= 2 then
      Dec[0] += Bits[LedStatus[I]] * Exp;
    if I <= 3 then
      Dec[1] += Bits[LedStatus[I + 3]] * Exp;
    Dec[2] += Bits[LedStatus[I + 7]] * Exp;
    Exp *= 2;
  end;
  for I := 1 to 3 do begin
    L := 8 - Length(MultTable[I, 1].Text);
    for J := 1 to L do
      MultTable[I, 1].Text := '0' + MultTable[I, 1].Text;
  end;
  // Fill-in decimal and (here calculated) hexadecimal values
  for I := 0 to 2 do begin
    MultTable[I + 1, 3].Text := '  ' + IntToStr(Dec[I]);
    if Dec[I] < 10 then
      MultTable[I + 1, 3].Text := ' ' + MultTable[I + 1, 3].Text;
    Hex1 := Dec[I] div 16; Hex2 := Dec[I] mod 16;
    MultTable[I + 1, 2].Text := '  ' + HexDigits[Hex1] + HexDigits[Hex2];
  end;
end;

{*************}
{ TfBinMult43 }
{*************}

{ Application start: Initialisation }

procedure TfBinMult43.FormCreate(Sender: TObject);

begin
  // Arrays with switches (transparent image and bar shapes) and their "on/off" status
  SetLength(aSwitches, 7); SetLength(bSwitches, 7);
  aSwitches[0].Switch0 := imSwitchA0; aSwitches[0].Switch1 := shSwitchA0a; aSwitches[0].Switch2 := shSwitchA0b;
  aSwitches[1].Switch0 := imSwitchA1; aSwitches[1].Switch1 := shSwitchA1a; aSwitches[1].Switch2 := shSwitchA1b;
  aSwitches[2].Switch0 := imSwitchA2; aSwitches[2].Switch1 := shSwitchA2a; aSwitches[2].Switch2 := shSwitchA2b;
  aSwitches[3].Switch0 := imSwitchB0; aSwitches[3].Switch1 := shSwitchB0a; aSwitches[3].Switch2 := shSwitchB0b;
  aSwitches[4].Switch0 := imSwitchB1; aSwitches[4].Switch1 := shSwitchB1a; aSwitches[4].Switch2 := shSwitchB1b;
  aSwitches[5].Switch0 := imSwitchB2; aSwitches[5].Switch1 := shSwitchB2a; aSwitches[5].Switch2 := shSwitchB2b;
  aSwitches[6].Switch0 := imSwitchB3; aSwitches[6].Switch1 := shSwitchB3a; aSwitches[6].Switch2 := shSwitchB3b;
  // Arrays with LEDs (shape) and their "on/off" status
  SetLength(aLeds, 14); SetLength(bLeds, 14);
  aLeds[0] := shLedA0; aLeds[1] := shLedA1; aLeds[2] := shLedA2;
  aLeds[3] := shLedB0; aLeds[4] := shLedB1; aLeds[5] := shLedB2; aLeds[6] := shLedB3;
  aLeds[7] := shLedC0; aLeds[8] := shLedC1; aLeds[9] := shLedC2; aLeds[10] := shLedC3;
  aLeds[11] := shLedC4; aLeds[12] := shLedC5; aLeds[13] := shLedC6;
  // Create array with "table" edit fields
  edMultTable[1, 1] := edMultiplierBin; edMultTable[1, 2] := edMultiplierHex; edMultTable[1, 3] := edMultiplierDec;
  edMultTable[2, 1] := edMultiplicandBin; edMultTable[2, 2] := edMultiplicandHex; edMultTable[2, 3] := edMultiplicandDec;
  edMultTable[3, 1] := edResultBin; edMultTable[3, 2] := edResultHex; edMultTable[3, 3] := edResultDec;
  // Use subscripts in input/output labels
  laA0.Caption := 'A' + SUB_Digits[0]; laA1.Caption := 'A' + SUB_Digits[1]; laA2.Caption := 'A' + SUB_Digits[2];
  laB0.Caption := 'B' + SUB_Digits[0]; laB1.Caption := 'B' + SUB_Digits[1];
  laB2.Caption := 'B' + SUB_Digits[2]; laB3.Caption := 'B' + SUB_Digits[3];
  laC0.Caption := 'C' + SUB_Digits[0]; laC1.Caption := 'C' + SUB_Digits[1];
  laC2.Caption := 'C' + SUB_Digits[2]; laC3.Caption := 'C' + SUB_Digits[3];
  laC4.Caption := 'C' + SUB_Digits[4]; laC5.Caption := 'C' + SUB_Digits[5]; laC6.Caption := 'C' + SUB_Digits[6];
end;

{ Application show-up: Initialize 4x3-bit multiplier simulation }

procedure TfBinMult43.FormActivate(Sender: TObject);

var
  I: Integer;

begin
  // All switches (inputs) to 0
  for I := 0 to Length(bSwitches) - 1 do
    bSwitches[I] := False;
  SwitchesOnOff(DSwitches, aSwitches, bSwitches);
  // All LEDs off
  for I := 0 to Length(bLeds) - 1 do
    bLeds[I] := False;
  LedsOnOff(aLeds, bLeds);
end;

{ Switch "A0, A1, A2, B0, B1, B2, B3" activated: Do 4x3-bits multiplier simulation for actual switch positions }

procedure TfBinMult43.imSwitchA0Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 0);
end;

procedure TfBinMult43.imSwitchA1Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 1);
end;

procedure TfBinMult43.imSwitchA2Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 2);
end;

procedure TfBinMult43.imSwitchB0Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 3);
end;

procedure TfBinMult43.imSwitchB1Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 4);
end;

procedure TfBinMult43.imSwitchB2Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 5);
end;

procedure TfBinMult43.imSwitchB3Click(Sender: TObject);

begin
  SwitchAndMult(DSwitches, aSwitches, bSwitches, aLeds, bLeds, edMultTable, 6);
end;

procedure TfBinMult43.btCloseClick(Sender: TObject);

begin
  Close;
end;

end.

